//+------------------------------------------------------------------+
//|                                               ThierryRSI_CCI.mq4 |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  LimeGreen
#property indicator_color4  Orange
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame       = PERIOD_CURRENT;
extern int             CCIPeriod       = 14;
extern int             RSIPeriod       = 8;
extern bool            alertsOn        = true;
extern bool            alertsOnCurrent = false;
extern bool            alertsMessage   = true;
extern bool            alertsSound     = false;
extern bool            alertsEmail     = false;

//
//
//
//
//

double Trend[];
double Direction[];
double hu[];
double hd[];
double hbu[];
double hbd[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
      SetIndexBuffer(0,hu);  SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,hd);  SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,hbu); SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,hbd); SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexBuffer(4, Trend);
      SetIndexBuffer(5, Direction);
        
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame==-99;
      TimeFrame         = MathMax(TimeFrame,_Period);
      IndicatorShortName(timeFrameToString(TimeFrame)+" ThierryRSI_CCI");
   return(0);
}
int deinit()
{
   return(0);
}




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars  = IndicatorCounted(); 
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
          int limit = MathMin(Bars - counted_bars,Bars-1);
          if (returnBars) { hu[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {
      for(int i = limit; i >= 0; i--)
      {
         double cciTrend = iCCI(NULL, 0, CCIPeriod, PRICE_TYPICAL, i);
         double rsiTrend = iRSI(NULL, 0, RSIPeriod, PRICE_TYPICAL, i);
         
         //
         //
         //
         //
         //
         
         hu[i]  = EMPTY_VALUE;
         hd[i]  = EMPTY_VALUE;
         hbu[i] = EMPTY_VALUE;
         hbd[i] = EMPTY_VALUE;
         Trend[i]     = Trend[i+1];
         Direction[i] = Direction[i+1];
            if (cciTrend > 0 && rsiTrend > 50) { Trend[i] = MathMax(Low[i]  - iATR(NULL, 0, 5, i),Trend[i+1]); Direction[i] =  1; }
            if (cciTrend < 0 && rsiTrend < 50) { Trend[i] = MathMin(High[i] + iATR(NULL, 0, 5, i),Trend[i+1]); Direction[i] = -1; }
            if (Direction[i] == 1)
            {
              hu[i]  = High[i]; 
              hd[i]  = Low[i];
              hbu[i] = MathMax(Open[i],Close[i]);
              hbd[i] = MathMin(Open[i],Close[i]);
            }               
            if (Direction[i] == -1)
            {
              hu[i]  = Low[i];
              hd[i]  = High[i];
              hbu[i] = MathMin(Open[i],Close[i]);
              hbd[i] = MathMax(Open[i],Close[i]);
            }               
   } 
   manageAlerts();   
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         Direction[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,CCIPeriod,RSIPeriod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,5,y);
         hu[i]  = EMPTY_VALUE;
         hd[i]  = EMPTY_VALUE;
         hbu[i] = EMPTY_VALUE;
         hbd[i] = EMPTY_VALUE;
         if (Direction[i]== 1)
         {
            hu[i]  = High[i]; 
            hd[i]  = Low[i];
            hbu[i] = MathMax(Open[i],Close[i]);
            hbd[i] = MathMin(Open[i],Close[i]);
         }               
         if (Direction[i]== -1)
         {
            hu[i]  = Low[i];
            hd[i]  = High[i];
            hbu[i] = MathMin(Open[i],Close[i]);
            hbd[i] = MathMax(Open[i],Close[i]);
         } 
   }
return(0);
}  

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//+------------------------------------------------------------------
//|                                                                 
//+------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      if (Direction[whichBar] != Direction[whichBar+1])
      {
         if (Direction[whichBar]== 1) doAlert(whichBar,"up");
         if (Direction[whichBar]==-1) doAlert(whichBar,"down");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Thiery RSI-CCI Candles changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Thiery RSI-CCI trend "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}